Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/SelfTest/src/test.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/SelfTest/src/test.cpp	(revision 112)
@@ -75,4 +75,5 @@
   ALLOC1_SC_SIGNAL( in_RETIRE_VAL               ," in_RETIRE_VAL               ",Tcontrol_t        ,_param->_nb_inst_retire);
   ALLOC1_SC_SIGNAL(out_RETIRE_ACK               ,"out_RETIRE_ACK               ",Tcontrol_t        ,_param->_nb_inst_retire);
+  ALLOC1_SC_SIGNAL( in_RETIRE_RESTORE           ," in_RETIRE_RESTORE           ",Tcontrol_t        ,_param->_nb_inst_retire);
   ALLOC1_SC_SIGNAL( in_RETIRE_READ_RA           ," in_RETIRE_READ_RA           ",Tcontrol_t        ,_param->_nb_inst_retire);
   ALLOC1_SC_SIGNAL( in_RETIRE_NUM_REG_RA_PHY    ," in_RETIRE_NUM_REG_RA_PHY    ",Tgeneral_address_t,_param->_nb_inst_retire);
@@ -121,4 +122,5 @@
   INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_VAL               ,_param->_nb_inst_retire);
   INSTANCE1_SC_SIGNAL(_Stat_List_unit,out_RETIRE_ACK               ,_param->_nb_inst_retire);
+  INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_RESTORE           ,_param->_nb_inst_retire);
   INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_READ_RA           ,_param->_nb_inst_retire);
   INSTANCE1_SC_SIGNAL(_Stat_List_unit, in_RETIRE_NUM_REG_RA_PHY    ,_param->_nb_inst_retire);
@@ -234,6 +236,7 @@
 		  TEST(bool, true,((gpr_status[reg]._is_free  == 0) and
 				   (gpr_status[reg]._is_link  == 0) and
-				   (gpr_status[reg]._is_valid == 1) and
-				   (gpr_status[reg]._counter  == 0)));
+				   (gpr_status[reg]._is_valid == 1)//  and
+// 				   (gpr_status[reg]._counter  == 0)
+                                   ));
 
 		  gpr_status[reg]._is_free = 1;
@@ -254,6 +257,7 @@
 		  TEST(bool, true,((spr_status[reg]._is_free  == 0) and
 				   (spr_status[reg]._is_link  == 0) and
-				   (spr_status[reg]._is_valid == 1) and
-				   (spr_status[reg]._counter  == 0)));
+				   (spr_status[reg]._is_valid == 1)//  and
+// 				   (spr_status[reg]._counter  == 0)
+                                   ));
 
 		  spr_status[reg]._is_free = 1;
@@ -301,7 +305,7 @@
 	      Tspecial_address_t re       = (it_spr != free_list_spr.end())?*it_spr:0;
 
-	      Tcontrol_t         read_ra  = (gpr_status_insert[ra]._is_link) and (gpr_status_insert[ra]._counter < _param->_max_reader);
-	      Tcontrol_t         read_rb  = (gpr_status_insert[rb]._is_link) and (gpr_status_insert[rb]._counter < _param->_max_reader);
-	      Tcontrol_t         read_rc  = (spr_status_insert[rc]._is_link) and (spr_status_insert[rc]._counter < _param->_max_reader);
+	      Tcontrol_t         read_ra  = (gpr_status_insert[ra]._is_link); // and (gpr_status_insert[ra]._counter < _param->_max_reader);
+	      Tcontrol_t         read_rb  = (gpr_status_insert[rb]._is_link); // and (gpr_status_insert[rb]._counter < _param->_max_reader);
+	      Tcontrol_t         read_rc  = (spr_status_insert[rc]._is_link); // and (spr_status_insert[rc]._counter < _param->_max_reader);
 	      Tcontrol_t         write_rd = (it_gpr != free_list_gpr.end());
 	      Tcontrol_t         write_re = (it_spr != free_list_spr.end());
@@ -341,7 +345,7 @@
 	      Tspecial_address_t re_new   = (rand()%(_param->_nb_special_register  ))  ;
 
-	      Tcontrol_t         read_ra  = (gpr_status_retire[ra]._is_link) and (gpr_status_retire[ra]._counter > 0);
-	      Tcontrol_t         read_rb  = (gpr_status_retire[rb]._is_link) and (gpr_status_retire[rb]._counter > 0);
-	      Tcontrol_t         read_rc  = (spr_status_retire[rc]._is_link) and (spr_status_retire[rc]._counter > 0);
+	      Tcontrol_t         read_ra  = (gpr_status_retire[ra]._is_link); // and (gpr_status_retire[ra]._counter > 0);
+	      Tcontrol_t         read_rb  = (gpr_status_retire[rb]._is_link); // and (gpr_status_retire[rb]._counter > 0);
+	      Tcontrol_t         read_rc  = (spr_status_retire[rc]._is_link); // and (spr_status_retire[rc]._counter > 0);
 	      Tcontrol_t         write_rd = (    (gpr_status_retire[rd_old]._is_link ) and 
 					         (gpr_status_retire[rd_old]._is_valid) and
@@ -355,5 +359,6 @@
 	      in_RETIRE_VAL                [i]->write((rand()%100) < percent_transaction_retire);
 	      in_RETIRE_READ_RA            [i]->write(read_ra );
-	      in_RETIRE_NUM_REG_RA_PHY     [i]->write(ra);
+	      in_RETIRE_RESTORE            [i]->write(0);
+ 	      in_RETIRE_NUM_REG_RA_PHY     [i]->write(ra);
 	      in_RETIRE_READ_RB            [i]->write(read_rb );
 	      in_RETIRE_NUM_REG_RB_PHY     [i]->write(rb);
@@ -502,4 +507,5 @@
 	    if (in_RETIRE_VAL [i]->read() and out_RETIRE_ACK [i]->read())
 	      {
+		Tcontrol_t         restore        = in_RETIRE_RESTORE            [i]->read();
 		Tcontrol_t         read_ra        = in_RETIRE_READ_RA            [i]->read();
 		Tgeneral_address_t ra             = in_RETIRE_NUM_REG_RA_PHY     [i]->read();
@@ -518,4 +524,5 @@
 
 		LABEL("RETIRE [%d] - Accepted",i);
+		LABEL(" * restore          : %d",restore);
 		LABEL(" * read_ra          : %d",read_ra );
 		LABEL(" * reg_ra           : %d",ra      );
@@ -575,9 +582,18 @@
 		if (write_rd)
 		  {
-                    if (restore_rd_old)
+                    if (restore)
                       {
-                        gpr_status[rd_old]._is_link  = 1;
-                        gpr_status[rd_new]._is_link  = 0;
-                        gpr_status[rd_new]._is_valid = 1;
+                        if (restore_rd_old)
+                          {
+                            gpr_status[rd_old]._is_link  = 1;
+                            gpr_status[rd_new]._is_link  = 0;
+                            gpr_status[rd_new]._is_valid = 1;
+                          }
+                        else
+                          {
+                            gpr_status[rd_old]._is_link  = 0;
+                            gpr_status[rd_new]._is_link  = 0;
+                            gpr_status[rd_new]._is_valid = 1;
+                          }
                       }
                     else
@@ -586,4 +602,5 @@
                         gpr_status[rd_new]._is_valid = 1;
                       }
+
 		  }
 		if (write_re)
@@ -619,6 +636,7 @@
 		  TEST(bool, true,((gpr_status[reg]._is_free  == 0) and
 				   (gpr_status[reg]._is_link  == 0) and
-				   (gpr_status[reg]._is_valid == 1) and
-				   (gpr_status[reg]._counter  == 0)));
+				   (gpr_status[reg]._is_valid == 1)//  and
+// 				   (gpr_status[reg]._counter  == 0)
+                                   ));
 
 		  gpr_status[reg]._is_free = 1;
@@ -639,6 +657,7 @@
 		  TEST(bool, true,((spr_status[reg]._is_free  == 0) and
 				   (spr_status[reg]._is_link  == 0) and
-				   (spr_status[reg]._is_valid == 1) and
-				   (spr_status[reg]._counter  == 0)));
+				   (spr_status[reg]._is_valid == 1)//  and
+// 				   (spr_status[reg]._counter  == 0)
+                                   ));
 
 		  spr_status[reg]._is_free = 1;
@@ -678,4 +697,5 @@
   delete []  in_RETIRE_VAL               ;
   delete [] out_RETIRE_ACK               ;
+  delete []  in_RETIRE_RESTORE           ;
   delete []  in_RETIRE_READ_RA           ;
   delete []  in_RETIRE_NUM_REG_RA_PHY    ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/include/Parameters.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/include/Parameters.h	(revision 112)
@@ -34,10 +34,10 @@
   public : uint32_t   _nb_reg_free           ;
   public : uint32_t   _nb_bank               ;
-  public : uint32_t   _size_counter          ;
+//public : uint32_t   _size_counter          ;
 
 //public : uint32_t   _size_general_register ;
 //public : uint32_t   _size_special_register ;
 		      
-  public : uint32_t   _max_reader            ;
+//public : uint32_t   _max_reader            ;
   public : uint32_t   _nb_gpr_use_init       ;
   public : uint32_t   _nb_spr_use_init       ;
@@ -63,5 +63,5 @@
 			uint32_t   nb_reg_free           ,
 			uint32_t   nb_bank               ,
-			uint32_t   size_counter          ,
+// 			uint32_t   size_counter          ,
                         bool       is_toplevel=false
                         );
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/include/Stat_List_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/include/Stat_List_unit.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/include/Stat_List_unit.h	(revision 112)
@@ -79,4 +79,5 @@
   public    : SC_IN (Tcontrol_t        )   **  in_RETIRE_VAL               ;//[nb_inst_retire]
   public    : SC_OUT(Tcontrol_t        )   ** out_RETIRE_ACK               ;//[nb_inst_retire]
+  public    : SC_IN (Tcontrol_t        )   **  in_RETIRE_RESTORE           ;//[nb_inst_retire]
   public    : SC_IN (Tcontrol_t        )   **  in_RETIRE_READ_RA           ;//[nb_inst_retire]
   public    : SC_IN (Tgeneral_address_t)   **  in_RETIRE_NUM_REG_RA_PHY    ;//[nb_inst_retire]
@@ -110,8 +111,8 @@
   private   : stat_list_entry_t            ** spr_stat_list; //[nb_bank][nb_general_register_by_bank]
 
+  private   : uint32_t                        reg_GPR_PTR_FREE;
+  private   : uint32_t                        reg_SPR_PTR_FREE;
+
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  private   : uint32_t                        internal_GPR_PTR_FREE;
-  private   : uint32_t                        internal_SPR_PTR_FREE;
-
   private   : Tcontrol_t                    * internal_INSERT_ACK       ;//[nb_inst_insert]
   private   : Tcontrol_t                    * internal_RETIRE_ACK       ;//[nb_inst_retire]
@@ -154,5 +155,5 @@
   public  : void        transition                (void);
   public  : void        genMoore                  (void);
-  public  : void        genMealy                  (void);
+//public  : void        genMealy                  (void);
 #endif					       
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/include/Types.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/include/Types.h	(revision 112)
@@ -25,6 +25,6 @@
   public : bool     _is_free ; // set = is present in free list
   public : bool     _is_link ; // set = is present in rat
-  public : bool     _is_valid; // set = an instruction have write in this register
-  public : uint32_t _counter ; // number of register that must read this register
+//public : bool     _is_valid; // set = an instruction have write in this register
+//public : uint32_t _counter ; // number of register that must read this register
 
   public :  stat_list_entry_t (void) {};
@@ -35,42 +35,46 @@
       _is_free  = 0;
       _is_link  = is_link;
-      _is_valid = 1;
-      _counter  = 0;
+//    _is_valid = 1;
+//    _counter  = 0;
     }
 
-  public : void insert_read (void)
-    {
-      _counter ++;
-    }
+//   public : void insert_read (void)
+//     {
+//    _counter ++;
+//     }
+
   public : void insert_write (void)
     {
       _is_free  = 0;
       _is_link  = 1;
-      _is_valid = 0;
+//    _is_valid = 0;
     }
 
-  public : void retire_read (void)
+//   public : void retire_read (void)
+//     {
+//    _counter --;
+//     }
+
+  public : void retire_write_old (bool restore, bool restore_old)
     {
-      _counter --;
+      // restore restore_old is_link
+      // 0       x           0       - normal case : unallocate
+      // 1       0           0       - event and previous update
+      // 1       1           1       - event and first update
+      
+      _is_link = restore and restore_old;
     }
 
-  public : void retire_write_old (bool restore_old)
+  public : void retire_write_new (bool restore, bool restore_old)
     {
-      if (not restore_old)
-        {
-          _is_link  = 0;
-        }
-      // else nothing
-    }
+      // restore restore_old is_link
+      // 0       x           1       - normal case : allocate
+      // 1       x           0       - event, need restore oldest register
 
-  public : void retire_write_new (bool restore_old)
-    {
-      if (restore_old)
-        {
-          _is_link  = 0;
-        }
+      if (restore)
+        _is_link = 0;
 
       // in all case
-      _is_valid = 1;
+//    _is_valid = 1;
     }
 
@@ -80,15 +84,16 @@
     }
 
-  public : bool can_insert_read (uint32_t max_reader)
-    {
-      return ((_counter+1) < max_reader);
-    }
+//   public : bool can_insert_read (uint32_t max_reader)
+//     {
+//    return ((_counter+1) < max_reader);
+//     }
 
   public : bool can_free (void)
     {
       return ((_is_free  == 0) and
-	      (_is_link  == 0) and
-// 	      (_is_valid == 1) and // if is_link <- 0, then retire_write_old or reset
-	      (_counter  == 0));
+	      (_is_link  == 0) // and
+//  	      (_is_valid == 1) and // if is_link <- 0, then retire_write_old or reset
+// 	      (_counter  == 0)
+              );
     }
 
@@ -97,7 +102,8 @@
     {
       output << x._is_free  << " "
-             << x._is_link  << " "
-             << x._is_valid << " "
-             << x._counter;
+             << x._is_link  // << " "
+//           << x._is_valid  << " "
+//              << x._counter
+        ;
       
       return output;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/src/Parameters.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/src/Parameters.cpp	(revision 112)
@@ -29,5 +29,5 @@
 			  uint32_t   nb_reg_free           ,
 			  uint32_t   nb_bank               ,
-			  uint32_t   size_counter          ,
+// 			  uint32_t   size_counter          ,
                           bool       is_toplevel)
   {
@@ -42,7 +42,7 @@
     _nb_reg_free            = nb_reg_free        ;
     _nb_bank                = nb_bank            ;
-    _size_counter           = size_counter       ;
+//  _size_counter           = size_counter       ;
 
-    _max_reader             = 1<<size_counter;
+//  _max_reader             = 1<<size_counter;
 
     uint32_t nb_thread = 0;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/src/Parameters_print.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/src/Parameters_print.cpp	(revision 112)
@@ -35,5 +35,5 @@
     xml.singleton_begin("nb_reg_free        "); xml.attribut("value",toString(_nb_reg_free        )); xml.singleton_end();
     xml.singleton_begin("nb_bank            "); xml.attribut("value",toString(_nb_bank            )); xml.singleton_end();
-    xml.singleton_begin("size_counter       "); xml.attribut("value",toString(_size_counter       )); xml.singleton_end();
+//     xml.singleton_begin("size_counter       "); xml.attribut("value",toString(_size_counter       )); xml.singleton_end();
 
     for (uint32_t i=0;i<_nb_front_end; i++)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/src/Stat_List_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/src/Stat_List_unit.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/src/Stat_List_unit.cpp	(revision 112)
@@ -75,4 +75,9 @@
       {
 	// Constant
+	for (uint32_t i=0; i<_param->_nb_inst_insert; i++)
+	  {
+	    internal_INSERT_ACK[i] = 1;
+	    PORT_WRITE(out_INSERT_ACK[i], internal_INSERT_ACK[i]);
+	  }
 	for (uint32_t i=0; i<_param->_nb_inst_retire; i++)
 	  {
@@ -101,30 +106,30 @@
 # endif    
 
-	log_printf(INFO,Stat_List_unit,FUNCTION,"Method - genMealy");
+// 	log_printf(INFO,Stat_List_unit,FUNCTION,"Method - genMealy");
 
-	SC_METHOD (genMealy);
-	dont_initialize ();
-	sensitive << (*(in_CLOCK)).neg(); // need internal register
-	for (uint32_t i=0; i<_param->_nb_inst_insert; i++)
-	  sensitive << (*(in_INSERT_READ_RA        [i]))
-		    << (*(in_INSERT_NUM_REG_RA_PHY [i]))
-		    << (*(in_INSERT_READ_RB        [i]))
-		    << (*(in_INSERT_NUM_REG_RB_PHY [i]))
-		    << (*(in_INSERT_READ_RC        [i]))
-		    << (*(in_INSERT_NUM_REG_RC_PHY [i]));
+// 	SC_METHOD (genMealy);
+// 	dont_initialize ();
+// 	sensitive << (*(in_CLOCK)).neg(); // need internal register
+// 	for (uint32_t i=0; i<_param->_nb_inst_insert; i++)
+// 	  sensitive << (*(in_INSERT_READ_RA        [i]))
+// 		    << (*(in_INSERT_NUM_REG_RA_PHY [i]))
+// 		    << (*(in_INSERT_READ_RB        [i]))
+// 		    << (*(in_INSERT_NUM_REG_RB_PHY [i]))
+// 		    << (*(in_INSERT_READ_RC        [i]))
+// 		    << (*(in_INSERT_NUM_REG_RC_PHY [i]));
 
-# ifdef SYSTEMCASS_SPECIFIC
-	// List dependency information
+// # ifdef SYSTEMCASS_SPECIFIC
+// 	// List dependency information
 
-	for (uint32_t i=0; i<_param->_nb_inst_insert; i++)
-	  {
-	    (*(out_INSERT_ACK [i])) (*(in_INSERT_READ_RA        [i]));
-	    (*(out_INSERT_ACK [i])) (*(in_INSERT_NUM_REG_RA_PHY [i]));
-	    (*(out_INSERT_ACK [i])) (*(in_INSERT_READ_RB        [i]));
-	    (*(out_INSERT_ACK [i])) (*(in_INSERT_NUM_REG_RB_PHY [i]));
-	    (*(out_INSERT_ACK [i])) (*(in_INSERT_READ_RC        [i]));
-	    (*(out_INSERT_ACK [i])) (*(in_INSERT_NUM_REG_RC_PHY [i]));
-	  }
-# endif    
+// 	for (uint32_t i=0; i<_param->_nb_inst_insert; i++)
+// 	  {
+// 	    (*(out_INSERT_ACK [i])) (*(in_INSERT_READ_RA        [i]));
+// 	    (*(out_INSERT_ACK [i])) (*(in_INSERT_NUM_REG_RA_PHY [i]));
+// 	    (*(out_INSERT_ACK [i])) (*(in_INSERT_READ_RB        [i]));
+// 	    (*(out_INSERT_ACK [i])) (*(in_INSERT_NUM_REG_RB_PHY [i]));
+// 	    (*(out_INSERT_ACK [i])) (*(in_INSERT_READ_RC        [i]));
+// 	    (*(out_INSERT_ACK [i])) (*(in_INSERT_NUM_REG_RC_PHY [i]));
+// 	  }
+// # endif    
 	
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/src/Stat_List_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/src/Stat_List_unit_allocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Stat_List_unit/src/Stat_List_unit_allocation.cpp	(revision 112)
@@ -49,5 +49,5 @@
 							 ,IN
 							 ,SOUTH,
-							 "Generalist interface"
+							 _("Generalist interface")
 #endif
 							 );
@@ -58,5 +58,5 @@
      // ~~~~~[ Interface "insert" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("insert",IN,SOUTH,"Insert a renaming result",_param->_nb_inst_insert);
+       ALLOC1_INTERFACE_BEGIN("insert",IN,SOUTH,_("Insert a renaming result"),_param->_nb_inst_insert);
 
        ALLOC1_VALACK_IN ( in_INSERT_VAL               ,VAL);
@@ -72,12 +72,15 @@
        ALLOC1_SIGNAL_IN ( in_INSERT_WRITE_RE          ,"write_re"          ,Tcontrol_t        ,1                             );
        ALLOC1_SIGNAL_IN ( in_INSERT_NUM_REG_RE_PHY_NEW,"num_reg_re_phy_new",Tspecial_address_t,_param->_size_special_register);
+
+       ALLOC1_INTERFACE_END(_param->_nb_inst_insert);
      }
 
      // ~~~~~[ Interface "retire" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("retire",IN,NORTH,"Retire a renaming result",_param->_nb_inst_retire);
+       ALLOC1_INTERFACE_BEGIN("retire",IN,NORTH,_("Retire a renaming result"),_param->_nb_inst_retire);
 
        ALLOC1_VALACK_IN ( in_RETIRE_VAL               ,VAL);
        ALLOC1_VALACK_OUT(out_RETIRE_ACK               ,ACK);
+       ALLOC1_SIGNAL_IN ( in_RETIRE_RESTORE           ,"restore"           ,Tcontrol_t        ,1                             );
        ALLOC1_SIGNAL_IN ( in_RETIRE_READ_RA           ,"read_ra"           ,Tcontrol_t        ,1                             );
        ALLOC1_SIGNAL_IN ( in_RETIRE_NUM_REG_RA_PHY    ,"num_reg_ra_phy"    ,Tgeneral_address_t,_param->_size_general_register);
@@ -94,22 +97,28 @@
        ALLOC1_SIGNAL_IN ( in_RETIRE_NUM_REG_RE_PHY_OLD,"num_reg_re_phy_old",Tspecial_address_t,_param->_size_special_register);
        ALLOC1_SIGNAL_IN ( in_RETIRE_NUM_REG_RE_PHY_NEW,"num_reg_re_phy_new",Tspecial_address_t,_param->_size_special_register);
+
+       ALLOC1_INTERFACE_END(_param->_nb_inst_retire);
      }
 
      // ~~~~~[ interface : "push_gpr" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("push_gpr",OUT,SOUTH,"Free a general register",_param->_nb_reg_free);
+       ALLOC1_INTERFACE_BEGIN("push_gpr",OUT,SOUTH,_("Free a general register"),_param->_nb_reg_free);
 
        ALLOC1_VALACK_OUT(out_PUSH_GPR_VAL    ,VAL);
        ALLOC1_VALACK_IN ( in_PUSH_GPR_ACK    ,ACK);
        ALLOC1_SIGNAL_OUT(out_PUSH_GPR_NUM_REG,"num_reg",Tgeneral_address_t,_param->_size_general_register);
+
+       ALLOC1_INTERFACE_END(_param->_nb_reg_free);
      }
 
      // ~~~~~[ interface : "push_spr" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("push_spr",OUT,SOUTH,"Free a special register",_param->_nb_reg_free);
+       ALLOC1_INTERFACE_BEGIN("push_spr",OUT,SOUTH,_("Free a special register"),_param->_nb_reg_free);
 
        ALLOC1_VALACK_OUT(out_PUSH_SPR_VAL    ,VAL);
        ALLOC1_VALACK_IN ( in_PUSH_SPR_ACK    ,ACK);
        ALLOC1_SIGNAL_OUT(out_PUSH_SPR_NUM_REG,"num_reg",Tspecial_address_t,_param->_size_special_register);
+
+       ALLOC1_INTERFACE_END(_param->_nb_reg_free);
      }
 
@@ -117,19 +126,12 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-     gpr_stat_list = new stat_list_entry_t * [_param->_nb_bank];
-     spr_stat_list = new stat_list_entry_t * [_param->_nb_bank];
-
-     for (uint32_t i=0; i<_param->_nb_bank; i++)
-       {
-	 gpr_stat_list [i] = new stat_list_entry_t [_param->_nb_general_register_by_bank];
-	 spr_stat_list [i] = new stat_list_entry_t [_param->_nb_special_register_by_bank];
-       }       
-
-     internal_INSERT_ACK        = new Tcontrol_t [_param->_nb_inst_insert];
-     internal_RETIRE_ACK        = new Tcontrol_t [_param->_nb_inst_retire];
-     internal_PUSH_GPR_VAL      = new Tcontrol_t [_param->_nb_reg_free];
-     internal_PUSH_GPR_NUM_BANK = new uint32_t   [_param->_nb_reg_free];
-     internal_PUSH_SPR_VAL      = new Tcontrol_t [_param->_nb_reg_free];
-     internal_PUSH_SPR_NUM_BANK = new uint32_t   [_param->_nb_reg_free];
+     ALLOC2(gpr_stat_list,stat_list_entry_t,_param->_nb_bank,_param->_nb_general_register_by_bank);
+     ALLOC2(spr_stat_list,stat_list_entry_t,_param->_nb_bank,_param->_nb_special_register_by_bank);
+     ALLOC1(internal_INSERT_ACK       ,Tcontrol_t,_param->_nb_inst_insert);
+     ALLOC1(internal_RETIRE_ACK       ,Tcontrol_t,_param->_nb_inst_retire);
+     ALLOC1(internal_PUSH_GPR_VAL     ,Tcontrol_t,_param->_nb_reg_free);
+     ALLOC1(internal_PUSH_GPR_NUM_BANK,uint32_t  ,_param->_nb_reg_free);
+     ALLOC1(internal_PUSH_SPR_VAL     ,Tcontrol_t,_param->_nb_reg_free);
+     ALLOC1(internal_PUSH_SPR_NUM_BANK,uint32_t  ,_param->_nb_reg_free);
       }
 
